unit mkSFX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  StdCtrls;

function FileSizeOf(FileName: string): LongInt;
function MakeSFXFile(StubName, UPDName, EXEName: string): Boolean;

implementation

const
  BUFSIZE = 8192;
  COUNT: LONGINT = 0;

var
  fromMe, updFileName: string;
  BUFFER: array[1..BUFSIZE] of BYTE;
  SFXlength: LONGINT;

function FileSizeOf(FileName: string): LongInt;
var
  sr: TSearchrec;
  sResult: Word;
begin
  FileSizeOf := 0;
  sResult := FindFirst(FileName, $00, sr);
  if sResult = 0 then FileSizeOf := sr.size;
  Sysutils.FindClose(sr);
end;

function StubOK(StubName: string): Boolean;
begin
  Result := false;
  if fileexists(StubName) then result := true else
    MessageBox(0, 'UpdateSFXStub not found.', 'Create SFX', mb_IconStop);
end;

function UpdOK(UPDName: string): Boolean;
begin
  Result := false;
  if fileexists(UPDName) then result := true else
    MessageBox(0, 'Update File not found.', 'Create SFX', mb_IconStop);
end;


function MakeSFXFile(StubName, UPDName, EXEName: string): Boolean;
(*glue two files together to an SFX-Update*)
var
  InFile, OutFile: file;
  FSIZE: LONGINT;
  DRESULT: DWORD;
begin
  Result := false;
  if not StubOK(StubName) then exit;
  if not UpdOK(UPDName) then exit;
  ///////////// copy stub to exe
  COUNT := 0;
  AssignFile(InFile, StubName);
  FileMode := 0; // read only
(*$I-*) RESET(InFile, 1); (*$I+*)
  if ioresult <> 0 then
  begin
    MessageBox(0, 'Could not open UpdateSFXStub.', 'Create SFX', mb_IconStop);
    exit;
  end;
  FileMode := 2; // read and write
  AssignFile(OutFile, EXEName);
(*$I-*) REWRITE(OutFile, 1); (*$I+*)
  if ioresult <> 0 then
  begin
    MessageBox(0, 'Could not create temporary file.', 'Create SFX', mb_IconStop);
    CloseFile(InFile);
    exit;
  end;

  repeat
    FileMode := 0;
    BLOCKREAD(InFile, BUFFER, BUFSIZE, DRESULT);
    FileMode := 2;
    BLOCKWRITE(OutFile, BUFFER, DRESULT);
    INC(COUNT, DRESULT);
  until (COUNT = FSIZE) or (DRESULT <> BUFSIZE);
  CloseFile(InFile); // ready with the stub

  ///////////// append upd to exe
  COUNT := 0;
  AssignFile(InFile, UPDName);
  FileMode := 0; // read only
(*$I-*) RESET(InFile, 1); (*$I+*)
  if ioresult <> 0 then
  begin
    MessageBox(0, 'Could not open Update File.', 'Create SFX', mb_IconStop);
    CloseFile(OutFile);
    exit;
  end;

  repeat
    FileMode := 0;
    BLOCKREAD(InFile, BUFFER, BUFSIZE, DRESULT);
    FileMode := 2;
    BLOCKWRITE(OutFile, BUFFER, DRESULT);
    INC(COUNT, DRESULT);
  until (COUNT = FSIZE) or (DRESULT <> BUFSIZE);
  CloseFile(InFile); // ready with the upd
  CloseFile(OutFile); // ready with the exe
  Result := FileExists(EXEName);
end;


end.

